# Interface SignatureSpec

All Known Implementing Classes:
  `Sign, SignOperation`

public interface SignatureSpec
Specifies how objects will be signed.

Since:
  1.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Signatory`
  `getSignatory()`
  The signatory that will be performing the signing.
  `SignatureType`
  `getSignatureType()`
  The signature representation that will be created.
  `boolean`
  `isRequired()`
  Whether or not it is required that this signature be generated.
  `void`
  `setRequired(boolean required)`
  Whether or not it is required that this signature be generated.
  `void`
  `setSignatory(Signatory signatory)`
  Sets the signatory that will be signing the input.
  `void`
  `setSignatureType(SignatureType type)`
  Sets the signature representation that the signatures will be produced as.

- ## Method Details

  - ### getSignatory

    Signatory getSignatory()
    The signatory that will be performing the signing.
    Returns:
      the signatory, or `null` if none specified.
    Since:
      1.0

  - ### setSignatory

    void setSignatory(Signatory signatory)
    Sets the signatory that will be signing the input.
    Parameters:
      `signatory` - The signatory
    Since:
      1.0

  - ### getSignatureType

    SignatureType getSignatureType()
    The signature representation that will be created.
    Returns:
      the signature type, or `null` if none specified.
    Since:
      1.0

  - ### setSignatureType

    void setSignatureType(SignatureType type)
    Sets the signature representation that the signatures will be produced as.
    Parameters:
      `type` - the signature type to use
    Since:
      1.0

  - ### isRequired

    boolean isRequired()
    Whether or not it is required that this signature be generated. A signature may not be able to be generated if a signatory and/or a signature type have not been specified. If it is required and cannot be generated, an exception will be thrown. Otherwise, it will not be generated.
    Returns:
      Whether or not it is required that this signature be generated.
    Since:
      1.0

  - ### setRequired

    void setRequired(boolean required)
    Whether or not it is required that this signature be generated.
    Parameters:
      `required` - Whether or not it is required that this signature be generated.
    Since:
      1.0
    See Also:
      - `isRequired()`